/* Entry.c generated by valac 0.38.4, the Vala compiler
 * generated from Entry.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define DRTGTK_TYPE_ENTRY (drtgtk_entry_get_type ())
#define DRTGTK_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTGTK_TYPE_ENTRY, DrtgtkEntry))
#define DRTGTK_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTGTK_TYPE_ENTRY, DrtgtkEntryClass))
#define DRTGTK_IS_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTGTK_TYPE_ENTRY))
#define DRTGTK_IS_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTGTK_TYPE_ENTRY))
#define DRTGTK_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTGTK_TYPE_ENTRY, DrtgtkEntryClass))

typedef struct _DrtgtkEntry DrtgtkEntry;
typedef struct _DrtgtkEntryClass DrtgtkEntryClass;
typedef struct _DrtgtkEntryPrivate DrtgtkEntryPrivate;
enum  {
	DRTGTK_ENTRY_0_PROPERTY,
	DRTGTK_ENTRY_NUM_PROPERTIES
};
static GParamSpec* drtgtk_entry_properties[DRTGTK_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	DRTGTK_ENTRY_ESCAPE_SIGNAL,
	DRTGTK_ENTRY_NUM_SIGNALS
};
static guint drtgtk_entry_signals[DRTGTK_ENTRY_NUM_SIGNALS] = {0};

struct _DrtgtkEntry {
	GtkEntry parent_instance;
	DrtgtkEntryPrivate * priv;
};

struct _DrtgtkEntryClass {
	GtkEntryClass parent_class;
};


static gpointer drtgtk_entry_parent_class = NULL;

GType drtgtk_entry_get_type (void) G_GNUC_CONST;
DrtgtkEntry* drtgtk_entry_new (const gchar* text);
DrtgtkEntry* drtgtk_entry_construct (GType object_type, const gchar* text);
gboolean drtgtk_entry_copy_to_clipboard (DrtgtkEntry* self);
static gboolean drtgtk_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event);


DrtgtkEntry* drtgtk_entry_construct (GType object_type, const gchar* text) {
	DrtgtkEntry * self = NULL;
	const gchar* _tmp0_;
	self = (DrtgtkEntry*) g_object_new (object_type, NULL);
	_tmp0_ = text;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = text;
		gtk_entry_set_text ((GtkEntry*) self, _tmp1_);
	}
	return self;
}


DrtgtkEntry* drtgtk_entry_new (const gchar* text) {
	return drtgtk_entry_construct (DRTGTK_TYPE_ENTRY, text);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


gboolean drtgtk_entry_copy_to_clipboard (DrtgtkEntry* self) {
	gboolean result = FALSE;
	GtkWindow* window = NULL;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ != NULL) {
		GtkClipboard* clipboard = NULL;
		GtkWindow* _tmp3_;
		GdkDisplay* _tmp4_;
		GtkClipboard* _tmp5_;
		GtkClipboard* _tmp6_;
		GtkClipboard* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp3_ = window;
		_tmp4_ = gtk_widget_get_display ((GtkWidget*) _tmp3_);
		_tmp5_ = gtk_clipboard_get_for_display (_tmp4_, GDK_SELECTION_CLIPBOARD);
		_tmp6_ = _g_object_ref0 (_tmp5_);
		clipboard = _tmp6_;
		_tmp7_ = clipboard;
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp9_ = _tmp8_;
		gtk_clipboard_set_text (_tmp7_, _tmp9_, -1);
		result = TRUE;
		_g_object_unref0 (clipboard);
		_g_object_unref0 (window);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (window);
	return result;
}


static gboolean drtgtk_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
	DrtgtkEntry * self;
	gboolean result = FALSE;
	GdkEventKey* _tmp0_;
	guint _tmp1_;
	self = (DrtgtkEntry*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->keyval;
	if (_tmp1_ == ((guint) GDK_KEY_Escape)) {
		g_signal_emit (self, drtgtk_entry_signals[DRTGTK_ENTRY_ESCAPE_SIGNAL], 0);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void drtgtk_entry_class_init (DrtgtkEntryClass * klass) {
	drtgtk_entry_parent_class = g_type_class_peek_parent (klass);
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget *, GdkEventKey*)) drtgtk_entry_real_key_press_event;
	drtgtk_entry_signals[DRTGTK_ENTRY_ESCAPE_SIGNAL] = g_signal_new ("escape", DRTGTK_TYPE_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void drtgtk_entry_instance_init (DrtgtkEntry * self) {
}


GType drtgtk_entry_get_type (void) {
	static volatile gsize drtgtk_entry_type_id__volatile = 0;
	if (g_once_init_enter (&drtgtk_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtgtkEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drtgtk_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtgtkEntry), 0, (GInstanceInitFunc) drtgtk_entry_instance_init, NULL };
		GType drtgtk_entry_type_id;
		drtgtk_entry_type_id = g_type_register_static (gtk_entry_get_type (), "DrtgtkEntry", &g_define_type_info, 0);
		g_once_init_leave (&drtgtk_entry_type_id__volatile, drtgtk_entry_type_id);
	}
	return drtgtk_entry_type_id__volatile;
}



