/* JsonValue.c generated by valac 0.38.4, the Vala compiler
 * generated from JsonValue.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define DRT_TYPE_JSON_VALUE_TYPE (drt_json_value_type_get_type ())

#define DRT_TYPE_JSON_NODE (drt_json_node_get_type ())
#define DRT_JSON_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_JSON_NODE, DrtJsonNode))
#define DRT_JSON_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_JSON_NODE, DrtJsonNodeClass))
#define DRT_IS_JSON_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_JSON_NODE))
#define DRT_IS_JSON_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_JSON_NODE))
#define DRT_JSON_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_JSON_NODE, DrtJsonNodeClass))

typedef struct _DrtJsonNode DrtJsonNode;
typedef struct _DrtJsonNodeClass DrtJsonNodeClass;
typedef struct _DrtJsonNodePrivate DrtJsonNodePrivate;

#define DRT_TYPE_JSON_VALUE (drt_json_value_get_type ())
#define DRT_JSON_VALUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_JSON_VALUE, DrtJsonValue))
#define DRT_JSON_VALUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_JSON_VALUE, DrtJsonValueClass))
#define DRT_IS_JSON_VALUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_JSON_VALUE))
#define DRT_IS_JSON_VALUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_JSON_VALUE))
#define DRT_JSON_VALUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_JSON_VALUE, DrtJsonValueClass))

typedef struct _DrtJsonValue DrtJsonValue;
typedef struct _DrtJsonValueClass DrtJsonValueClass;
typedef struct _DrtJsonValuePrivate DrtJsonValuePrivate;
enum  {
	DRT_JSON_VALUE_0_PROPERTY,
	DRT_JSON_VALUE_NUM_PROPERTIES
};
static GParamSpec* drt_json_value_properties[DRT_JSON_VALUE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	DRT_JSON_VALUE_TYPE_NULL,
	DRT_JSON_VALUE_TYPE_BOOLEAN,
	DRT_JSON_VALUE_TYPE_STRING,
	DRT_JSON_VALUE_TYPE_INTEGER,
	DRT_JSON_VALUE_TYPE_DOUBLE
} DrtJsonValueType;

struct _DrtJsonNode {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtJsonNodePrivate * priv;
	DrtJsonNode* parent;
};

struct _DrtJsonNodeClass {
	GTypeClass parent_class;
	void (*finalize) (DrtJsonNode *self);
	gchar* (*to_string) (DrtJsonNode* self);
};

struct _DrtJsonValue {
	DrtJsonNode parent_instance;
	DrtJsonValuePrivate * priv;
};

struct _DrtJsonValueClass {
	DrtJsonNodeClass parent_class;
};

struct _DrtJsonValuePrivate {
	DrtJsonValueType _value_type;
	gint int_value;
	gdouble double_value;
	gchar* string_value;
};


static gpointer drt_json_value_parent_class = NULL;

GType drt_json_value_type_get_type (void) G_GNUC_CONST;
gpointer drt_json_node_ref (gpointer instance);
void drt_json_node_unref (gpointer instance);
GParamSpec* drt_param_spec_json_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_json_node (GValue* value, gpointer v_object);
void drt_value_take_json_node (GValue* value, gpointer v_object);
gpointer drt_value_get_json_node (const GValue* value);
GType drt_json_node_get_type (void) G_GNUC_CONST;
GType drt_json_value_get_type (void) G_GNUC_CONST;
#define DRT_JSON_VALUE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_JSON_VALUE, DrtJsonValuePrivate))
gchar* drt_json_value_escape_string (const gchar* str);
DrtJsonValue* drt_json_value_new_null (void);
DrtJsonValue* drt_json_value_construct_null (GType object_type);
DrtJsonNode* drt_json_node_construct (GType object_type);
void drt_json_value_set_value_type (DrtJsonValue* self, DrtJsonValueType value);
DrtJsonValue* drt_json_value_new_bool (gboolean bool_value);
DrtJsonValue* drt_json_value_construct_bool (GType object_type, gboolean bool_value);
DrtJsonValue* drt_json_value_new_int (gint int_value);
DrtJsonValue* drt_json_value_construct_int (GType object_type, gint int_value);
DrtJsonValue* drt_json_value_new_double (gdouble double_value);
DrtJsonValue* drt_json_value_construct_double (GType object_type, gdouble double_value);
DrtJsonValue* drt_json_value_new_string (const gchar* string_value);
DrtJsonValue* drt_json_value_construct_string (GType object_type, const gchar* string_value);
const gchar* drt_json_value_get_string (DrtJsonValue* self);
DrtJsonValueType drt_json_value_get_value_type (DrtJsonValue* self);
gchar* drt_json_value_dup_string (DrtJsonValue* self);
gboolean drt_json_value_try_string (DrtJsonValue* self, gchar* * _result_);
gboolean drt_json_value_get_bool (DrtJsonValue* self);
gboolean drt_json_value_try_bool (DrtJsonValue* self, gboolean* _result_);
gint drt_json_value_get_int (DrtJsonValue* self);
gboolean drt_json_value_try_int (DrtJsonValue* self, gint* _result_);
gdouble drt_json_value_get_double (DrtJsonValue* self);
gboolean drt_json_value_try_double (DrtJsonValue* self, gdouble* _result_);
static gchar* drt_json_value_real_to_string (DrtJsonNode* base);
DrtJsonValue* drt_json_value_new (void);
DrtJsonValue* drt_json_value_construct (GType object_type);
static void drt_json_value_finalize (DrtJsonNode * obj);


/**
 * Types of values the {@link JsonValue} object can hold.
 */
GType drt_json_value_type_get_type (void) {
	static volatile gsize drt_json_value_type_type_id__volatile = 0;
	if (g_once_init_enter (&drt_json_value_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DRT_JSON_VALUE_TYPE_NULL, "DRT_JSON_VALUE_TYPE_NULL", "null"}, {DRT_JSON_VALUE_TYPE_BOOLEAN, "DRT_JSON_VALUE_TYPE_BOOLEAN", "boolean"}, {DRT_JSON_VALUE_TYPE_STRING, "DRT_JSON_VALUE_TYPE_STRING", "string"}, {DRT_JSON_VALUE_TYPE_INTEGER, "DRT_JSON_VALUE_TYPE_INTEGER", "integer"}, {DRT_JSON_VALUE_TYPE_DOUBLE, "DRT_JSON_VALUE_TYPE_DOUBLE", "double"}, {0, NULL, NULL}};
		GType drt_json_value_type_type_id;
		drt_json_value_type_type_id = g_enum_register_static ("DrtJsonValueType", values);
		g_once_init_leave (&drt_json_value_type_type_id__volatile, drt_json_value_type_type_id);
	}
	return drt_json_value_type_type_id__volatile;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = old;
		_tmp1_ = (*((gchar*) _tmp2_)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = old;
		_tmp4_ = replacement;
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp4_) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (self);
		result = _tmp5_;
		return result;
	}
	{
		GRegex* regex = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		GRegex* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = old;
		_tmp7_ = g_regex_escape_string (_tmp6_, -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_regex_new (_tmp8_, 0, 0, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		regex = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp12_ = regex;
		_tmp13_ = replacement;
		_tmp14_ = g_regex_replace_literal (_tmp12_, self, (gssize) -1, 0, _tmp13_, 0, &_inner_error_);
		_tmp11_ = _tmp14_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp15_ = _tmp11_;
		_tmp11_ = NULL;
		result = _tmp15_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally27;
	__catch27_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally27:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


gchar* drt_json_value_escape_string (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* _result_ = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	guint8 c = 0U;
	gint len = 0;
	const gchar* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	_tmp0_ = str;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("");
		result = _tmp1_;
		return result;
	}
	_tmp2_ = str;
	_tmp3_ = g_utf8_validate (_tmp2_, (gssize) -1, NULL);
	g_return_val_if_fail (_tmp3_, "");
	_tmp4_ = str;
	_tmp5_ = string_replace (_tmp4_, "\\", "\\\\");
	_tmp6_ = _tmp5_;
	_tmp7_ = string_replace (_tmp6_, "\"", "\\\"");
	_tmp8_ = _tmp7_;
	_tmp9_ = string_replace (_tmp8_, "\n", "\\n");
	_tmp10_ = _tmp9_;
	_tmp11_ = string_replace (_tmp10_, "\t", "\\t");
	_tmp12_ = _tmp11_;
	_tmp13_ = string_replace (_tmp12_, "\r", "\\r");
	_tmp14_ = _tmp13_;
	_tmp15_ = string_replace (_tmp14_, "\b", "\\b");
	_tmp16_ = _tmp15_;
	_tmp17_ = string_replace (_tmp16_, "\f", "\\f");
	_tmp18_ = _tmp17_;
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_result_ = _tmp18_;
	c = (guint8) 0;
	_tmp19_ = _result_;
	_tmp20_ = strlen (_tmp19_);
	_tmp21_ = _tmp20_;
	len = _tmp21_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				gboolean _tmp24_ = FALSE;
				gint _tmp25_;
				gint _tmp26_;
				guint8 _tmp33_;
				if (!_tmp22_) {
					gint _tmp23_;
					_tmp23_ = i;
					i = _tmp23_ + 1;
				}
				_tmp22_ = FALSE;
				_tmp25_ = i;
				_tmp26_ = len;
				if (_tmp25_ < _tmp26_) {
					const gchar* _tmp27_;
					guint8* _tmp28_;
					gint _tmp28__length1;
					guint8* _tmp29_;
					gint _tmp29__length1;
					gint _tmp30_;
					guint8 _tmp31_;
					guint8 _tmp32_;
					_tmp27_ = _result_;
					_tmp28_ = string_get_data (_tmp27_, &_tmp28__length1);
					_tmp29_ = _tmp28_;
					_tmp29__length1 = _tmp28__length1;
					_tmp30_ = i;
					_tmp31_ = _tmp29_[_tmp30_];
					c = _tmp31_;
					_tmp32_ = c;
					_tmp24_ = ((gint) _tmp32_) != 0;
				} else {
					_tmp24_ = FALSE;
				}
				if (!_tmp24_) {
					break;
				}
				_tmp33_ = c;
				if (((gint) _tmp33_) < 32) {
					const gchar* _tmp34_;
					guint8* _tmp35_;
					gint _tmp35__length1;
					guint8* _tmp36_;
					gint _tmp36__length1;
					gint _tmp37_;
					guint8 _tmp38_;
					_tmp34_ = _result_;
					_tmp35_ = string_get_data (_tmp34_, &_tmp35__length1);
					_tmp36_ = _tmp35_;
					_tmp36__length1 = _tmp35__length1;
					_tmp37_ = i;
					_tmp36_[_tmp37_] = (guint8) 32;
					_tmp38_ = _tmp36_[_tmp37_];
				}
			}
		}
	}
	result = _result_;
	return result;
}


/**
 * Creates a new null {@link JsonValue}.
 */
DrtJsonValue* drt_json_value_construct_null (GType object_type) {
	DrtJsonValue* self = NULL;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_NULL);
	return self;
}


DrtJsonValue* drt_json_value_new_null (void) {
	return drt_json_value_construct_null (DRT_TYPE_JSON_VALUE);
}


/**
 * Creates a new boolean {@link JsonValue}.
 * 
 * @param bool_value    Boolean value.
 */
DrtJsonValue* drt_json_value_construct_bool (GType object_type, gboolean bool_value) {
	DrtJsonValue* self = NULL;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_BOOLEAN);
	_tmp1_ = bool_value;
	if (_tmp1_) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	self->priv->int_value = _tmp0_;
	return self;
}


DrtJsonValue* drt_json_value_new_bool (gboolean bool_value) {
	return drt_json_value_construct_bool (DRT_TYPE_JSON_VALUE, bool_value);
}


/**
 * Creates a new integer number {@link JsonValue}.
 * 
 * @param int_value    Integer value.
 */
DrtJsonValue* drt_json_value_construct_int (GType object_type, gint int_value) {
	DrtJsonValue* self = NULL;
	gint _tmp0_;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_INTEGER);
	_tmp0_ = int_value;
	self->priv->int_value = _tmp0_;
	return self;
}


DrtJsonValue* drt_json_value_new_int (gint int_value) {
	return drt_json_value_construct_int (DRT_TYPE_JSON_VALUE, int_value);
}


/**
 * Creates a new floating point number {@link JsonValue}.
 * 
 * @param double_value    Double value.
 */
DrtJsonValue* drt_json_value_construct_double (GType object_type, gdouble double_value) {
	DrtJsonValue* self = NULL;
	gdouble _tmp0_;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_DOUBLE);
	_tmp0_ = double_value;
	self->priv->double_value = _tmp0_;
	return self;
}


DrtJsonValue* drt_json_value_new_double (gdouble double_value) {
	return drt_json_value_construct_double (DRT_TYPE_JSON_VALUE, double_value);
}


/**
 * Creates a new string {@link JsonValue}.
 * 
 * @param string_value    String value.
 */
DrtJsonValue* drt_json_value_construct_string (GType object_type, const gchar* string_value) {
	DrtJsonValue* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	drt_json_value_set_value_type (self, DRT_JSON_VALUE_TYPE_STRING);
	_tmp0_ = string_value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->string_value);
	self->priv->string_value = _tmp1_;
	return self;
}


DrtJsonValue* drt_json_value_new_string (const gchar* string_value) {
	return drt_json_value_construct_string (DRT_TYPE_JSON_VALUE, string_value);
}


/**
 * Get a string value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.STRING}. You might want to use {@link JsonNode.is_string} or
 * {@link JsonValue.try_string}.
 * 
 * @return the actual string value if this is of type {@link JsonValueType.STRING},
 *     undefined result otherwise
 */
const gchar* drt_json_value_get_string (DrtJsonValue* self) {
	const gchar* result = NULL;
	DrtJsonValueType _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_value_type;
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_STRING, NULL);
	_tmp1_ = self->priv->string_value;
	result = _tmp1_;
	return result;
}


/**
 * Duplicate a string value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.STRING}. You might want to use {@link JsonNode.is_string} or
 * {@link JsonValue.try_string}.
 * 
 * @return the copy of the actual string value if this is of type {@link JsonValueType.STRING},
 *     undefined result otherwise
 */
gchar* drt_json_value_dup_string (DrtJsonValue* self) {
	gchar* result = NULL;
	DrtJsonValueType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_value_type;
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_STRING, NULL);
	_tmp1_ = self->priv->string_value;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Try getting a string value
 * 
 * @param result    String value.
 * @return `true` if this holds {@link JsonValueType.STRING} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_string (DrtJsonValue* self, gchar* * _result_) {
	gchar* _vala_result = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	DrtJsonValueType _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->string_value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_vala_result);
	_vala_result = _tmp1_;
	_tmp2_ = self->priv->_value_type;
	result = _tmp2_ == DRT_JSON_VALUE_TYPE_STRING;
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_g_free0 (_vala_result);
	}
	return result;
}


/**
 * Get a boolean value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.BOOLEAN}. You might want to use {@link JsonNode.is_bool} or
 * {@link JsonValue.try_bool}.
 * 
 * @return the actual boolean value if this is of type {@link JsonValueType.BOOLEAN},
 *     undefined result otherwise
 */
gboolean drt_json_value_get_bool (DrtJsonValue* self) {
	gboolean result = FALSE;
	DrtJsonValueType _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_value_type;
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_BOOLEAN, FALSE);
	_tmp2_ = self->priv->int_value;
	if (_tmp2_ != 0) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	return result;
}


/**
 * Try getting a boolean value
 * 
 * @param result    Boolean value.
 * @return `true` if this holds {@link JsonValueType.BOOLEAN} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_bool (DrtJsonValue* self, gboolean* _result_) {
	gboolean _vala_result = FALSE;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	DrtJsonValueType _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->int_value;
	if (_tmp1_ != 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	_vala_result = _tmp0_;
	_tmp2_ = self->priv->_value_type;
	result = _tmp2_ == DRT_JSON_VALUE_TYPE_BOOLEAN;
	if (_result_) {
		*_result_ = _vala_result;
	}
	return result;
}


/**
 * Get an integer value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.INTEGER}. You might want to use {@link JsonNode.is_int} or
 * {@link JsonValue.try_int}.
 * 
 * @return the actual integer value if this is of type {@link JsonValueType.INTEGER},
 *     undefined result otherwise
 */
gint drt_json_value_get_int (DrtJsonValue* self) {
	gint result = 0;
	DrtJsonValueType _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_value_type;
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_INTEGER, 0);
	_tmp1_ = self->priv->int_value;
	result = _tmp1_;
	return result;
}


/**
 * Try getting an integer number value
 * 
 * @param result    Integer value.
 * @return `true` if this holds {@link JsonValueType.INTEGER} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_int (DrtJsonValue* self, gint* _result_) {
	gint _vala_result = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	DrtJsonValueType _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->int_value;
	_vala_result = _tmp0_;
	_tmp1_ = self->priv->_value_type;
	result = _tmp1_ == DRT_JSON_VALUE_TYPE_INTEGER;
	if (_result_) {
		*_result_ = _vala_result;
	}
	return result;
}


/**
 * Get a floating point number value
 * 
 * It is a programmer error to call this method if the {@link value_type} of this is not
 * {@link JsonValueType.DOUBLE}. You might want to use {@link JsonNode.is_double} or
 * {@link JsonValue.try_double}.
 * 
 * @return the actual double value if this is of type {@link JsonValueType.DOUBLE},
 *     undefined result otherwise
 */
gdouble drt_json_value_get_double (DrtJsonValue* self) {
	gdouble result = 0.0;
	DrtJsonValueType _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_value_type;
	g_return_val_if_fail (_tmp0_ == DRT_JSON_VALUE_TYPE_DOUBLE, 0.0);
	_tmp1_ = self->priv->double_value;
	result = _tmp1_;
	return result;
}


/**
 * Try getting a floating point number value
 * 
 * @param result    Double value.
 * @return `true` if this holds {@link JsonValueType.DOUBLE} and so `result` is valid,
 *     `false` otherwise
 */
gboolean drt_json_value_try_double (DrtJsonValue* self, gdouble* _result_) {
	gdouble _vala_result = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_;
	DrtJsonValueType _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->double_value;
	_vala_result = _tmp0_;
	_tmp1_ = self->priv->_value_type;
	result = _tmp1_ == DRT_JSON_VALUE_TYPE_DOUBLE;
	if (_result_) {
		*_result_ = _vala_result;
	}
	return result;
}


/**
 * Return string representation of the node.
 * 
 * @return a string representation of the node
 */
static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


static gchar* drt_json_value_real_to_string (DrtJsonNode* base) {
	DrtJsonValue * self;
	gchar* result = NULL;
	DrtJsonValueType _tmp0_;
	self = (DrtJsonValue*) base;
	_tmp0_ = self->priv->_value_type;
	switch (_tmp0_) {
		case DRT_JSON_VALUE_TYPE_NULL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("null");
			result = _tmp1_;
			return result;
		}
		case DRT_JSON_VALUE_TYPE_BOOLEAN:
		{
			const gchar* _tmp2_ = NULL;
			gint _tmp3_;
			gchar* _tmp4_;
			_tmp3_ = self->priv->int_value;
			if (_tmp3_ != 0) {
				_tmp2_ = "true";
			} else {
				_tmp2_ = "false";
			}
			_tmp4_ = g_strdup (_tmp2_);
			result = _tmp4_;
			return result;
		}
		case DRT_JSON_VALUE_TYPE_INTEGER:
		{
			gint _tmp5_;
			gchar* _tmp6_;
			_tmp5_ = self->priv->int_value;
			_tmp6_ = g_strdup_printf ("%i", _tmp5_);
			result = _tmp6_;
			return result;
		}
		case DRT_JSON_VALUE_TYPE_DOUBLE:
		{
			gdouble _tmp7_;
			gchar* _tmp8_;
			_tmp7_ = self->priv->double_value;
			_tmp8_ = double_to_string (_tmp7_);
			result = _tmp8_;
			return result;
		}
		case DRT_JSON_VALUE_TYPE_STRING:
		{
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp9_ = self->priv->string_value;
			_tmp10_ = drt_json_value_escape_string (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strdup_printf ("\"%s\"", _tmp11_);
			_tmp13_ = _tmp12_;
			_g_free0 (_tmp11_);
			result = _tmp13_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


DrtJsonValue* drt_json_value_construct (GType object_type) {
	DrtJsonValue* self = NULL;
	self = (DrtJsonValue*) drt_json_node_construct (object_type);
	return self;
}


DrtJsonValue* drt_json_value_new (void) {
	return drt_json_value_construct (DRT_TYPE_JSON_VALUE);
}


DrtJsonValueType drt_json_value_get_value_type (DrtJsonValue* self) {
	DrtJsonValueType result;
	DrtJsonValueType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_value_type;
	result = _tmp0_;
	return result;
}


void drt_json_value_set_value_type (DrtJsonValue* self, DrtJsonValueType value) {
	DrtJsonValueType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_value_type = _tmp0_;
}


static void drt_json_value_class_init (DrtJsonValueClass * klass) {
	drt_json_value_parent_class = g_type_class_peek_parent (klass);
	((DrtJsonNodeClass *) klass)->finalize = drt_json_value_finalize;
	g_type_class_add_private (klass, sizeof (DrtJsonValuePrivate));
	((DrtJsonNodeClass *) klass)->to_string = (gchar* (*) (DrtJsonNode *)) drt_json_value_real_to_string;
}


static void drt_json_value_instance_init (DrtJsonValue * self) {
	self->priv = DRT_JSON_VALUE_GET_PRIVATE (self);
	self->priv->_value_type = DRT_JSON_VALUE_TYPE_NULL;
	self->priv->int_value = 0;
	self->priv->double_value = 0.0;
	self->priv->string_value = NULL;
}


static void drt_json_value_finalize (DrtJsonNode * obj) {
	DrtJsonValue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_JSON_VALUE, DrtJsonValue);
	_g_free0 (self->priv->string_value);
	DRT_JSON_NODE_CLASS (drt_json_value_parent_class)->finalize (obj);
}


/**
 * JSON Value holds boolean, integer, float, string and null values.
 */
GType drt_json_value_get_type (void) {
	static volatile gsize drt_json_value_type_id__volatile = 0;
	if (g_once_init_enter (&drt_json_value_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtJsonValueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_json_value_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtJsonValue), 0, (GInstanceInitFunc) drt_json_value_instance_init, NULL };
		GType drt_json_value_type_id;
		drt_json_value_type_id = g_type_register_static (DRT_TYPE_JSON_NODE, "DrtJsonValue", &g_define_type_info, 0);
		g_once_init_leave (&drt_json_value_type_id__volatile, drt_json_value_type_id);
	}
	return drt_json_value_type_id__volatile;
}



