/* Queryable.c generated by valac 0.38.4, the Vala compiler
 * generated from Queryable.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define DRTDB_TYPE_QUERYABLE (drtdb_queryable_get_type ())
#define DRTDB_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryable))
#define DRTDB_IS_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERYABLE))
#define DRTDB_QUERYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryableIface))

typedef struct _DrtdbQueryable DrtdbQueryable;
typedef struct _DrtdbQueryableIface DrtdbQueryableIface;

#define DRTDB_TYPE_QUERY (drtdb_query_get_type ())
#define DRTDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERY, DrtdbQuery))
#define DRTDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_QUERY, DrtdbQueryClass))
#define DRTDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERY))
#define DRTDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_QUERY))
#define DRTDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_QUERY, DrtdbQueryClass))

typedef struct _DrtdbQuery DrtdbQuery;
typedef struct _DrtdbQueryClass DrtdbQueryClass;

#define DRTDB_TYPE_OBJECT_QUERY (drtdb_object_query_get_type ())
#define DRTDB_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQuery))
#define DRTDB_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))
#define DRTDB_IS_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_IS_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_OBJECT_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))

typedef struct _DrtdbObjectQuery DrtdbObjectQuery;
typedef struct _DrtdbObjectQueryClass DrtdbObjectQueryClass;

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()
struct _DrtdbQueryableIface {
	GTypeInterface parent_iface;
	void (*exec) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbQuery* (*query) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbObjectQuery* (*get_objects) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
	gpointer (*get_object) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
	const gchar* (*get_last_error_message) (DrtdbQueryable* self);
};



GQuark drtdb_database_error_quark (void);
GType drtdb_query_get_type (void) G_GNUC_CONST;
GType drtdb_object_query_get_type (void) G_GNUC_CONST;
GType drtdb_queryable_get_type (void) G_GNUC_CONST;
void drtdb_queryable_exec (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
DrtdbQuery* drtdb_queryable_query (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
DrtdbObjectQuery* drtdb_queryable_get_objects (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
gpointer drtdb_queryable_get_object (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
const gchar* drtdb_queryable_get_last_error_message (DrtdbQueryable* self);


/**
 * Execute a sql query on database conection
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
void drtdb_queryable_exec (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error) {
	g_return_if_fail (self != NULL);
	DRTDB_QUERYABLE_GET_INTERFACE (self)->exec (self, sql, cancellable, error);
}


/**
 * Create new raw data query
 * 
 * After query is created, primitive data types can be bound prior execution.
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_queryable_query (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRTDB_QUERYABLE_GET_INTERFACE (self)->query (self, sql, cancellable, error);
}


/**
 * Get ORM objects
 * 
 * @param cancellable    Cancellable object
 * @return new ORM query object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbObjectQuery* drtdb_queryable_get_objects (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRTDB_QUERYABLE_GET_INTERFACE (self)->get_objects (self, t_type, t_dup_func, t_destroy_func, cancellable, error);
}


/**
 * Get a single ORM object
 * 
 * @param pk             value of primary key
 * @param cancellable    Cancellable object
 * @return new ORM object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
gpointer drtdb_queryable_get_object (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRTDB_QUERYABLE_GET_INTERFACE (self)->get_object (self, t_type, t_dup_func, t_destroy_func, pk, cancellable, error);
}


const gchar* drtdb_queryable_get_last_error_message (DrtdbQueryable* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRTDB_QUERYABLE_GET_INTERFACE (self)->get_last_error_message (self);
}


static void drtdb_queryable_base_init (DrtdbQueryableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


/**
 * SQLite queryable object
 */
GType drtdb_queryable_get_type (void) {
	static volatile gsize drtdb_queryable_type_id__volatile = 0;
	if (g_once_init_enter (&drtdb_queryable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtdbQueryableIface), (GBaseInitFunc) drtdb_queryable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType drtdb_queryable_type_id;
		drtdb_queryable_type_id = g_type_register_static (G_TYPE_INTERFACE, "DrtdbQueryable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (drtdb_queryable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&drtdb_queryable_type_id__volatile, drtdb_queryable_type_id);
	}
	return drtdb_queryable_type_id__volatile;
}



