/* Random.c generated by valac 0.38.4, the Vala compiler
 * generated from Random.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* drt_random_hex (gint n_bits);
void drt_uint32_to_bytes (guint8** buffer, int* buffer_length1, guint32 data, guint offset);
void drt_bin_to_hex (guint8* array, int array_length1, gchar* * _result_, gchar separator);
void drt_random_bin (gint n_bits, guint8** _result_, int* _result__length1);


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @return Random binary data.
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_;
		gint _tmp7_;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_;
		glong _tmp13_;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


gchar* drt_random_hex (gint n_bits) {
	gchar* result = NULL;
	gint n_bytes = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint n_32bits = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint size = 0;
	gint _tmp8_;
	guint8* buffer = NULL;
	gint _tmp9_;
	guint8* _tmp10_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _result_ = NULL;
	guint8* _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gint _tmp20_;
	gint _tmp21_;
	_tmp0_ = n_bits;
	n_bytes = _tmp0_ / 8;
	_tmp1_ = n_bytes;
	_tmp2_ = n_bits;
	if ((_tmp1_ * 8) < _tmp2_) {
		gint _tmp3_;
		_tmp3_ = n_bytes;
		n_bytes = _tmp3_ + 1;
	}
	_tmp4_ = n_bytes;
	n_32bits = _tmp4_ / 4;
	_tmp5_ = n_32bits;
	_tmp6_ = n_bytes;
	if ((_tmp5_ * 4) < _tmp6_) {
		gint _tmp7_;
		_tmp7_ = n_32bits;
		n_32bits = _tmp7_ + 1;
	}
	_tmp8_ = n_32bits;
	size = _tmp8_ * 4;
	_tmp9_ = size;
	_tmp10_ = g_new0 (guint8, _tmp9_);
	buffer = _tmp10_;
	buffer_length1 = _tmp9_;
	_buffer_size_ = buffer_length1;
	{
		guint offset = 0U;
		offset = (guint) 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				guint _tmp13_;
				gint _tmp14_;
				guint32 _tmp15_;
				guint _tmp16_;
				if (!_tmp11_) {
					guint _tmp12_;
					_tmp12_ = offset;
					offset = _tmp12_ + 4;
				}
				_tmp11_ = FALSE;
				_tmp13_ = offset;
				_tmp14_ = size;
				if (!((_tmp13_ + 4) <= ((guint) _tmp14_))) {
					break;
				}
				_tmp15_ = g_random_int ();
				_tmp16_ = offset;
				drt_uint32_to_bytes (&buffer, &buffer_length1, _tmp15_, _tmp16_);
			}
		}
	}
	_tmp17_ = buffer;
	_tmp17__length1 = buffer_length1;
	drt_bin_to_hex (_tmp17_, _tmp17__length1, &_tmp18_, '\0');
	_g_free0 (_result_);
	_result_ = _tmp18_;
	_tmp20_ = size;
	_tmp21_ = n_bytes;
	if (_tmp20_ == _tmp21_) {
		const gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp22_ = _result_;
		_tmp23_ = g_strdup (_tmp22_);
		_g_free0 (_tmp19_);
		_tmp19_ = _tmp23_;
	} else {
		const gchar* _tmp24_;
		gint _tmp25_;
		gchar* _tmp26_;
		_tmp24_ = _result_;
		_tmp25_ = n_bytes;
		_tmp26_ = string_substring (_tmp24_, (glong) 0, (glong) (_tmp25_ * 2));
		_g_free0 (_tmp19_);
		_tmp19_ = _tmp26_;
	}
	result = _tmp19_;
	_g_free0 (_result_);
	buffer = (g_free (buffer), NULL);
	return result;
}


/**
 * Generate random binary data as a hexadecimal string.
 * 
 * @param n_bits    Number of random bits. Will be rounded up to the nearest byte.
 * @param result    Random binary data.
 */
void drt_random_bin (gint n_bits, guint8** _result_, int* _result__length1) {
	guint8* _vala_result = NULL;
	int _vala_result_length1 = 0;
	gint n_bytes = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint n_32bits = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint size = 0;
	gint _tmp8_;
	gint _tmp9_;
	guint8* _tmp10_;
	_tmp0_ = n_bits;
	n_bytes = _tmp0_ / 8;
	_tmp1_ = n_bytes;
	_tmp2_ = n_bits;
	if ((_tmp1_ * 8) < _tmp2_) {
		gint _tmp3_;
		_tmp3_ = n_bytes;
		n_bytes = _tmp3_ + 1;
	}
	_tmp4_ = n_bytes;
	n_32bits = _tmp4_ / 4;
	_tmp5_ = n_32bits;
	_tmp6_ = n_bytes;
	if ((_tmp5_ * 4) < _tmp6_) {
		gint _tmp7_;
		_tmp7_ = n_32bits;
		n_32bits = _tmp7_ + 1;
	}
	_tmp8_ = n_32bits;
	size = _tmp8_ * 4;
	_tmp9_ = size;
	_tmp10_ = g_new0 (guint8, _tmp9_);
	_vala_result = (g_free (_vala_result), NULL);
	_vala_result = _tmp10_;
	_vala_result_length1 = _tmp9_;
	{
		guint offset = 0U;
		offset = (guint) 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				guint _tmp13_;
				gint _tmp14_;
				guint32 _tmp15_;
				guint _tmp16_;
				if (!_tmp11_) {
					guint _tmp12_;
					_tmp12_ = offset;
					offset = _tmp12_ + 4;
				}
				_tmp11_ = FALSE;
				_tmp13_ = offset;
				_tmp14_ = size;
				if (!((_tmp13_ + 4) <= ((guint) _tmp14_))) {
					break;
				}
				_tmp15_ = g_random_int ();
				_tmp16_ = offset;
				drt_uint32_to_bytes (&_vala_result, &_vala_result_length1, _tmp15_, _tmp16_);
			}
		}
	}
	if (_result_) {
		*_result_ = _vala_result;
	} else {
		_vala_result = (g_free (_vala_result), NULL);
	}
	if (_result__length1) {
		*_result__length1 = _vala_result_length1;
	}
}



