/* RpcConnection.c generated by valac 0.38.4, the Vala compiler
 * generated from RpcConnection.vala, do not modify */

/*
 * Copyright 2016-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_RPC_CONNECTION (drt_rpc_connection_get_type ())
#define DRT_RPC_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_CONNECTION, DrtRpcConnection))
#define DRT_RPC_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_CONNECTION, DrtRpcConnectionClass))
#define DRT_IS_RPC_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_CONNECTION))
#define DRT_IS_RPC_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_CONNECTION))
#define DRT_RPC_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_CONNECTION, DrtRpcConnectionClass))

typedef struct _DrtRpcConnection DrtRpcConnection;
typedef struct _DrtRpcConnectionClass DrtRpcConnectionClass;
typedef struct _DrtRpcConnectionPrivate DrtRpcConnectionPrivate;

#define DRT_TYPE_RPC_ROUTER (drt_rpc_router_get_type ())
#define DRT_RPC_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RPC_ROUTER, DrtRpcRouter))
#define DRT_RPC_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RPC_ROUTER, DrtRpcRouterClass))
#define DRT_IS_RPC_ROUTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RPC_ROUTER))
#define DRT_IS_RPC_ROUTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RPC_ROUTER))
#define DRT_RPC_ROUTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RPC_ROUTER, DrtRpcRouterClass))

typedef struct _DrtRpcRouter DrtRpcRouter;
typedef struct _DrtRpcRouterClass DrtRpcRouterClass;
enum  {
	DRT_RPC_CONNECTION_0_PROPERTY,
	DRT_RPC_CONNECTION_ROUTER_PROPERTY,
	DRT_RPC_CONNECTION_ID_PROPERTY,
	DRT_RPC_CONNECTION_API_TOKEN_PROPERTY,
	DRT_RPC_CONNECTION_NUM_PROPERTIES
};
static GParamSpec* drt_rpc_connection_properties[DRT_RPC_CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _DrtRpcConnectionCallData DrtRpcConnectionCallData;
typedef struct _DrtRpcConnectionSubscribeData DrtRpcConnectionSubscribeData;
typedef struct _DrtRpcConnectionUnsubscribeData DrtRpcConnectionUnsubscribeData;

struct _DrtRpcConnection {
	GObject parent_instance;
	DrtRpcConnectionPrivate * priv;
};

struct _DrtRpcConnectionClass {
	GObjectClass parent_class;
	void (*call_full) (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GVariant* (*call_full_finish) (DrtRpcConnection* self, GAsyncResult* _res_, GError** error);
	GVariant* (*call_full_sync) (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GError** error);
	void (*respond) (DrtRpcConnection* self, guint id, GVariant* response);
	void (*fail) (DrtRpcConnection* self, guint id, GError* e);
};

struct _DrtRpcConnectionPrivate {
	DrtRpcRouter* _router;
	guint _id;
	gchar* _api_token;
};

struct _DrtRpcConnectionCallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DrtRpcConnection* self;
	gchar* method;
	GVariant* parameters;
	GVariant* result;
	GVariant* _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GError * _inner_error_;
};

struct _DrtRpcConnectionSubscribeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DrtRpcConnection* self;
	gchar* notification;
	gchar* detail;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GError * _inner_error_;
};

struct _DrtRpcConnectionUnsubscribeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DrtRpcConnection* self;
	gchar* notification;
	gchar* detail;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GError * _inner_error_;
};


static gpointer drt_rpc_connection_parent_class = NULL;

GType drt_rpc_connection_get_type (void) G_GNUC_CONST;
GType drt_rpc_router_get_type (void) G_GNUC_CONST;
#define DRT_RPC_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_RPC_CONNECTION, DrtRpcConnectionPrivate))
static void drt_rpc_connection_call_data_free (gpointer _data);
void drt_rpc_connection_call (DrtRpcConnection* self, const gchar* method, GVariant* parameters, GAsyncReadyCallback _callback_, gpointer _user_data_);
GVariant* drt_rpc_connection_call_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error);
static gboolean drt_rpc_connection_call_co (DrtRpcConnectionCallData* _data_);
void drt_rpc_connection_call_full (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GAsyncReadyCallback _callback_, gpointer _user_data_);
GVariant* drt_rpc_connection_call_full_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error);
static void drt_rpc_connection_call_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GVariant* drt_rpc_connection_call_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, GError** error);
GVariant* drt_rpc_connection_call_full_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GError** error);
static GVariant* drt_rpc_connection_real_call_full_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GError** error);
static void drt_rpc_connection_subscribe_data_free (gpointer _data);
void drt_rpc_connection_subscribe (DrtRpcConnection* self, const gchar* notification, const gchar* detail, GAsyncReadyCallback _callback_, gpointer _user_data_);
void drt_rpc_connection_subscribe_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error);
static gboolean drt_rpc_connection_subscribe_co (DrtRpcConnectionSubscribeData* _data_);
static void drt_rpc_connection_subscribe_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void drt_rpc_connection_unsubscribe_data_free (gpointer _data);
void drt_rpc_connection_unsubscribe (DrtRpcConnection* self, const gchar* notification, const gchar* detail, GAsyncReadyCallback _callback_, gpointer _user_data_);
void drt_rpc_connection_unsubscribe_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error);
static gboolean drt_rpc_connection_unsubscribe_co (DrtRpcConnectionUnsubscribeData* _data_);
static void drt_rpc_connection_unsubscribe_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void drt_rpc_connection_respond (DrtRpcConnection* self, guint id, GVariant* response);
static void drt_rpc_connection_real_respond (DrtRpcConnection* self, guint id, GVariant* response);
void drt_rpc_connection_fail (DrtRpcConnection* self, guint id, GError* e);
static void drt_rpc_connection_real_fail (DrtRpcConnection* self, guint id, GError* e);
DrtRpcConnection* drt_rpc_connection_construct (GType object_type);
DrtRpcRouter* drt_rpc_connection_get_router (DrtRpcConnection* self);
static void drt_rpc_connection_set_router (DrtRpcConnection* self, DrtRpcRouter* value);
guint drt_rpc_connection_get_id (DrtRpcConnection* self);
static void drt_rpc_connection_set_id (DrtRpcConnection* self, guint value);
const gchar* drt_rpc_connection_get_api_token (DrtRpcConnection* self);
void drt_rpc_connection_set_api_token (DrtRpcConnection* self, const gchar* value);
static void drt_rpc_connection_finalize (GObject * obj);
static void _vala_drt_rpc_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_rpc_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void drt_rpc_connection_call_data_free (gpointer _data) {
	DrtRpcConnectionCallData* _data_;
	_data_ = _data;
	_g_free0 (_data_->method);
	_g_variant_unref0 (_data_->parameters);
	_g_variant_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (DrtRpcConnectionCallData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


void drt_rpc_connection_call (DrtRpcConnection* self, const gchar* method, GVariant* parameters, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DrtRpcConnectionCallData* _data_;
	DrtRpcConnection* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	_data_ = g_slice_new0 (DrtRpcConnectionCallData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, drt_rpc_connection_call_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = method;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->method);
	_data_->method = _tmp2_;
	_tmp3_ = parameters;
	_tmp4_ = _g_variant_ref0 (_tmp3_);
	_g_variant_unref0 (_data_->parameters);
	_data_->parameters = _tmp4_;
	drt_rpc_connection_call_co (_data_);
}


GVariant* drt_rpc_connection_call_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error) {
	GVariant* result;
	DrtRpcConnectionCallData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


/**
 * Send remote request asynchronously (non-blocking).
 * 
 * @param method        Remote method name.
 * @param parameters    Remote method parameters.
 * @return Remote response.
 * @throws GLib.Error on failure.
 */
static void drt_rpc_connection_call_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DrtRpcConnectionCallData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	drt_rpc_connection_call_co (_data_);
}


static gboolean drt_rpc_connection_call_co (DrtRpcConnectionCallData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp1_ = _data_->method;
	_data_->_tmp2_ = _data_->parameters;
	_data_->_state_ = 1;
	drt_rpc_connection_call_full (_data_->self, _data_->_tmp1_, _data_->_tmp2_, TRUE, "rw", drt_rpc_connection_call_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp3_ = drt_rpc_connection_call_full_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
	_data_->_tmp0_ = _data_->_tmp3_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp4_ = _data_->_tmp0_;
	_data_->_tmp0_ = NULL;
	_data_->result = _data_->_tmp4_;
	_g_variant_unref0 (_data_->_tmp0_);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void drt_rpc_connection_call_full (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DRT_RPC_CONNECTION_GET_CLASS (self)->call_full (self, method, parameters, allow_private, flags, _callback_, _user_data_);
}


GVariant* drt_rpc_connection_call_full_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error) {
	return DRT_RPC_CONNECTION_GET_CLASS (self)->call_full_finish (self, _res_, error);
}


/**
 * Send remote request synchronously (blocking).
 * 
 * @param method        Remote method name.
 * @param parameters    Remote method parameters.
 * @return Remote response.
 * @throws GLib.Error on failure.
 */
GVariant* drt_rpc_connection_call_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, GError** error) {
	GVariant* result = NULL;
	GVariant* _tmp0_ = NULL;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (method != NULL, NULL);
	_tmp1_ = method;
	_tmp2_ = parameters;
	_tmp3_ = drt_rpc_connection_call_full_sync (self, _tmp1_, _tmp2_, TRUE, "rw", &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	_g_variant_unref0 (_tmp0_);
	return result;
}


/**
 * Send remote request synchronously (blocking) with additional options..
 * 
 * @param method        Remote method name.
 * @param parameters    Remote method parameters.
 * @param allow_private    Allow calling private methods.
 * @param flags            Remote call flags.
 * @return Remote response.
 * @throws GLib.Error on failure.
 */
static GVariant* drt_rpc_connection_real_call_full_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GError** error) {
	g_critical ("Type `%s' does not implement abstract method `drt_rpc_connection_call_full_sync'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


GVariant* drt_rpc_connection_call_full_sync (DrtRpcConnection* self, const gchar* method, GVariant* parameters, gboolean allow_private, const gchar* flags, GError** error) {
	g_return_val_if_fail (self != NULL, NULL);
	return DRT_RPC_CONNECTION_GET_CLASS (self)->call_full_sync (self, method, parameters, allow_private, flags, error);
}


static void drt_rpc_connection_subscribe_data_free (gpointer _data) {
	DrtRpcConnectionSubscribeData* _data_;
	_data_ = _data;
	_g_free0 (_data_->notification);
	_g_free0 (_data_->detail);
	_g_object_unref0 (_data_->self);
	g_slice_free (DrtRpcConnectionSubscribeData, _data_);
}


void drt_rpc_connection_subscribe (DrtRpcConnection* self, const gchar* notification, const gchar* detail, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DrtRpcConnectionSubscribeData* _data_;
	DrtRpcConnection* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	_data_ = g_slice_new0 (DrtRpcConnectionSubscribeData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, drt_rpc_connection_subscribe_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = notification;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->notification);
	_data_->notification = _tmp2_;
	_tmp3_ = detail;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->detail);
	_data_->detail = _tmp4_;
	drt_rpc_connection_subscribe_co (_data_);
}


void drt_rpc_connection_subscribe_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error) {
	DrtRpcConnectionSubscribeData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}


/**
 * Subscribe to notification.
 * 
 * @param notification    Notification path.
 * @param detail          Reserved for future use, pass `null`.
 * @throws GLib.Error on failure
 */
static void drt_rpc_connection_subscribe_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DrtRpcConnectionSubscribeData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	drt_rpc_connection_subscribe_co (_data_);
}


static gboolean drt_rpc_connection_subscribe_co (DrtRpcConnectionSubscribeData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->notification;
	_data_->_tmp1_ = _data_->detail;
	_data_->_tmp2_ = g_variant_new ("(bms)", TRUE, _data_->_tmp1_, NULL);
	g_variant_ref_sink (_data_->_tmp2_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_state_ = 1;
	drt_rpc_connection_call_full (_data_->self, _data_->_tmp0_, _data_->_tmp3_, TRUE, "ws", drt_rpc_connection_subscribe_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp4_ = drt_rpc_connection_call_full_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
	_data_->_tmp5_ = _data_->_tmp4_;
	_g_variant_unref0 (_data_->_tmp5_);
	_g_variant_unref0 (_data_->_tmp3_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void drt_rpc_connection_unsubscribe_data_free (gpointer _data) {
	DrtRpcConnectionUnsubscribeData* _data_;
	_data_ = _data;
	_g_free0 (_data_->notification);
	_g_free0 (_data_->detail);
	_g_object_unref0 (_data_->self);
	g_slice_free (DrtRpcConnectionUnsubscribeData, _data_);
}


void drt_rpc_connection_unsubscribe (DrtRpcConnection* self, const gchar* notification, const gchar* detail, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DrtRpcConnectionUnsubscribeData* _data_;
	DrtRpcConnection* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	_data_ = g_slice_new0 (DrtRpcConnectionUnsubscribeData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, drt_rpc_connection_unsubscribe_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = notification;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 (_data_->notification);
	_data_->notification = _tmp2_;
	_tmp3_ = detail;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (_data_->detail);
	_data_->detail = _tmp4_;
	drt_rpc_connection_unsubscribe_co (_data_);
}


void drt_rpc_connection_unsubscribe_finish (DrtRpcConnection* self, GAsyncResult* _res_, GError** error) {
	DrtRpcConnectionUnsubscribeData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}


/**
 * Unsubscribe from notification.
 * 
 * @param notification    Notification path.
 * @param detail          Reserved for future use, pass `null`.
 * @throws GLib.Error on failure
 */
static void drt_rpc_connection_unsubscribe_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DrtRpcConnectionUnsubscribeData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	drt_rpc_connection_unsubscribe_co (_data_);
}


static gboolean drt_rpc_connection_unsubscribe_co (DrtRpcConnectionUnsubscribeData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->notification;
	_data_->_tmp1_ = _data_->detail;
	_data_->_tmp2_ = g_variant_new ("(bms)", FALSE, _data_->_tmp1_, NULL);
	g_variant_ref_sink (_data_->_tmp2_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_state_ = 1;
	drt_rpc_connection_call_full (_data_->self, _data_->_tmp0_, _data_->_tmp3_, TRUE, "ws", drt_rpc_connection_unsubscribe_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp4_ = drt_rpc_connection_call_full_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
	_data_->_tmp5_ = _data_->_tmp4_;
	_g_variant_unref0 (_data_->_tmp5_);
	_g_variant_unref0 (_data_->_tmp3_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (g_task_get_completed (_data_->_async_result) != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


/**
 * Send a response to remote call.
 * 
 * @param id          Request id.
 * @param response    The response.
 */
static void drt_rpc_connection_real_respond (DrtRpcConnection* self, guint id, GVariant* response) {
	g_critical ("Type `%s' does not implement abstract method `drt_rpc_connection_respond'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void drt_rpc_connection_respond (DrtRpcConnection* self, guint id, GVariant* response) {
	g_return_if_fail (self != NULL);
	DRT_RPC_CONNECTION_GET_CLASS (self)->respond (self, id, response);
}


/**
 * Send an error to remote call.
 * 
 * @param id    Request id.
 * @param e     The error.
 */
static void drt_rpc_connection_real_fail (DrtRpcConnection* self, guint id, GError* e) {
	g_critical ("Type `%s' does not implement abstract method `drt_rpc_connection_fail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void drt_rpc_connection_fail (DrtRpcConnection* self, guint id, GError* e) {
	g_return_if_fail (self != NULL);
	DRT_RPC_CONNECTION_GET_CLASS (self)->fail (self, id, e);
}


DrtRpcConnection* drt_rpc_connection_construct (GType object_type) {
	DrtRpcConnection * self = NULL;
	self = (DrtRpcConnection*) g_object_new (object_type, NULL);
	return self;
}


DrtRpcRouter* drt_rpc_connection_get_router (DrtRpcConnection* self) {
	DrtRpcRouter* result;
	DrtRpcRouter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_router;
	result = _tmp0_;
	return result;
}


static void drt_rpc_connection_set_router (DrtRpcConnection* self, DrtRpcRouter* value) {
	g_return_if_fail (self != NULL);
	if (drt_rpc_connection_get_router (self) != value) {
		DrtRpcRouter* _tmp0_;
		DrtRpcRouter* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_router);
		self->priv->_router = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, drt_rpc_connection_properties[DRT_RPC_CONNECTION_ROUTER_PROPERTY]);
	}
}


guint drt_rpc_connection_get_id (DrtRpcConnection* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_id;
	result = _tmp0_;
	return result;
}


static void drt_rpc_connection_set_id (DrtRpcConnection* self, guint value) {
	g_return_if_fail (self != NULL);
	if (drt_rpc_connection_get_id (self) != value) {
		guint _tmp0_;
		_tmp0_ = value;
		self->priv->_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, drt_rpc_connection_properties[DRT_RPC_CONNECTION_ID_PROPERTY]);
	}
}


const gchar* drt_rpc_connection_get_api_token (DrtRpcConnection* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_api_token;
	result = _tmp0_;
	return result;
}


void drt_rpc_connection_set_api_token (DrtRpcConnection* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, drt_rpc_connection_get_api_token (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_api_token);
		self->priv->_api_token = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, drt_rpc_connection_properties[DRT_RPC_CONNECTION_API_TOKEN_PROPERTY]);
	}
}


static void drt_rpc_connection_class_init (DrtRpcConnectionClass * klass) {
	drt_rpc_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtRpcConnectionPrivate));
	((DrtRpcConnectionClass *) klass)->call_full_sync = (GVariant* (*) (DrtRpcConnection *, const gchar*, GVariant*, gboolean, const gchar*, GError**)) drt_rpc_connection_real_call_full_sync;
	((DrtRpcConnectionClass *) klass)->respond = (void (*) (DrtRpcConnection *, guint, GVariant*)) drt_rpc_connection_real_respond;
	((DrtRpcConnectionClass *) klass)->fail = (void (*) (DrtRpcConnection *, guint, GError*)) drt_rpc_connection_real_fail;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_rpc_connection_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_rpc_connection_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_rpc_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_RPC_CONNECTION_ROUTER_PROPERTY, drt_rpc_connection_properties[DRT_RPC_CONNECTION_ROUTER_PROPERTY] = g_param_spec_object ("router", "router", "router", DRT_TYPE_RPC_ROUTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_RPC_CONNECTION_ID_PROPERTY, drt_rpc_connection_properties[DRT_RPC_CONNECTION_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_RPC_CONNECTION_API_TOKEN_PROPERTY, drt_rpc_connection_properties[DRT_RPC_CONNECTION_API_TOKEN_PROPERTY] = g_param_spec_string ("api-token", "api-token", "api-token", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void drt_rpc_connection_instance_init (DrtRpcConnection * self) {
	self->priv = DRT_RPC_CONNECTION_GET_PRIVATE (self);
	self->priv->_api_token = NULL;
}


static void drt_rpc_connection_finalize (GObject * obj) {
	DrtRpcConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RPC_CONNECTION, DrtRpcConnection);
	_g_object_unref0 (self->priv->_router);
	_g_free0 (self->priv->_api_token);
	G_OBJECT_CLASS (drt_rpc_connection_parent_class)->finalize (obj);
}


/**
 * RPC Connection
 */
GType drt_rpc_connection_get_type (void) {
	static volatile gsize drt_rpc_connection_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rpc_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtRpcConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_rpc_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRpcConnection), 0, (GInstanceInitFunc) drt_rpc_connection_instance_init, NULL };
		GType drt_rpc_connection_type_id;
		drt_rpc_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtRpcConnection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&drt_rpc_connection_type_id__volatile, drt_rpc_connection_type_id);
	}
	return drt_rpc_connection_type_id__volatile;
}


static void _vala_drt_rpc_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtRpcConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RPC_CONNECTION, DrtRpcConnection);
	switch (property_id) {
		case DRT_RPC_CONNECTION_ROUTER_PROPERTY:
		g_value_set_object (value, drt_rpc_connection_get_router (self));
		break;
		case DRT_RPC_CONNECTION_ID_PROPERTY:
		g_value_set_uint (value, drt_rpc_connection_get_id (self));
		break;
		case DRT_RPC_CONNECTION_API_TOKEN_PROPERTY:
		g_value_set_string (value, drt_rpc_connection_get_api_token (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_rpc_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtRpcConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RPC_CONNECTION, DrtRpcConnection);
	switch (property_id) {
		case DRT_RPC_CONNECTION_ROUTER_PROPERTY:
		drt_rpc_connection_set_router (self, g_value_get_object (value));
		break;
		case DRT_RPC_CONNECTION_ID_PROPERTY:
		drt_rpc_connection_set_id (self, g_value_get_uint (value));
		break;
		case DRT_RPC_CONNECTION_API_TOKEN_PROPERTY:
		drt_rpc_connection_set_api_token (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



