/* String.c generated by valac 0.38.4, the Vala compiler
 * generated from String.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);



gboolean drt_string_is_empty (const gchar* str);
gchar* drt_string_null_if_empty (const gchar* str);
gchar* drt_string_concat (const gchar* initial, const gchar* separator, gchar* text);
void drt_string_append (gchar* * initial, const gchar* separator, gchar* text);
GSList* drt_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens);
GSList* drt_string_array_to_slist (gchar** array, int array_length1, gboolean strip);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
GHashTable* drt_string_semicolon_separated_set (const gchar* dataset, gboolean lowercase);
gint drt_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gint drt_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gchar* drt_string_unmask (guint8* data, int data_length1);
gint drt_string_utf16_strlen (const gchar* str);
const gchar* drt_string_offset (const gchar* str, gint offset);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Check whether string is empty, i.e. `null` or `""`.
 * 
 * @param str    string to test
 * @return true if string is empty, false otherwise
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


inline gboolean drt_string_is_empty (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	_tmp1_ = str;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		gchar _tmp3_;
		_tmp2_ = str;
		_tmp3_ = string_get (_tmp2_, (glong) 0);
		_tmp0_ = _tmp3_ == '\0';
	}
	result = _tmp0_;
	return result;
}


/**
 * Ensure string is not empty but either non-empty or null
 * 
 * @param str    original string
 * @return original string if it isn't empty, null otherwise
 */
inline gchar* drt_string_null_if_empty (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp6_;
	_tmp2_ = str;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp3_;
		gchar _tmp4_;
		_tmp3_ = str;
		_tmp4_ = string_get (_tmp3_, (glong) 0);
		_tmp1_ = _tmp4_ == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = NULL;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = str;
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp0_);
	result = _tmp6_;
	return result;
}


/**
 * Concatenate two strings with an optional separator
 * 
 * If the first string is empty, the second string is returned.
 * Otherwise, the strings are joined with the separator if specified.
 * 
 * @param initial     Initial string.
 * @param separator   A separator to include between strings.
 * @param text        The second string.
 * @return Joined string.
 */
gchar* drt_string_concat (const gchar* initial, const gchar* separator, gchar* text) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (text != NULL, NULL);
	_tmp0_ = initial;
	_tmp1_ = drt_string_is_empty (_tmp0_);
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = text;
		text = NULL;
		result = _tmp2_;
		_g_free0 (text);
		return result;
	}
	_tmp3_ = separator;
	_tmp4_ = drt_string_is_empty (_tmp3_);
	if (_tmp4_) {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp5_ = initial;
		_tmp6_ = text;
		_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
		result = _tmp7_;
		_g_free0 (text);
		return result;
	}
	_tmp8_ = initial;
	_tmp9_ = separator;
	_tmp10_ = g_strconcat (_tmp8_, _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = text;
	_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp11_);
	result = _tmp14_;
	_g_free0 (text);
	return result;
}


/**
 * Append string to the other string.
 * 
 * Separator is included if it is specified and the initial string is not empty.
 * 
 * @param initial      The initial string, which will be overwritten with the result.
 * @param separator    The separator which will be added if the initial string is not empty.
 * @param text         The text to append.
 */
void drt_string_append (gchar* * initial, const gchar* separator, gchar* text) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (text != NULL);
	_tmp0_ = *initial;
	_tmp1_ = separator;
	_tmp2_ = text;
	text = NULL;
	_tmp3_ = drt_string_concat (_tmp0_, _tmp1_, _tmp2_);
	_g_free0 (*initial);
	*initial = _tmp3_;
	_g_free0 (text);
}


/**	
 * Splits a string into a maximum of `max_tokens` pieces, using the given `delimiter` and ignoring
 * empty elements after stripping.
 * 
 * If `max_tokens` is reached, the remainder of string is appended to the last token.
 * 
 * @param data          a string to split
 * @param delimiter     a string which specifies the places at which to split the string. The delimiter is not
 *                      included in any of the resulting strings, unless `max_tokens` is reached.
 * @param max_tokens    the maximum number of pieces to split string into. If this is less than 1, the string 
 *                      is split completely.
 * @return resulting list of strings
 */
GSList* drt_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens) {
	GSList* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GSList* _tmp8_;
	GSList* _tmp9_;
	g_return_val_if_fail (delimiter != NULL, NULL);
	_tmp0_ = data;
	_tmp1_ = drt_string_is_empty (_tmp0_);
	if (_tmp1_) {
		result = NULL;
		return result;
	}
	_tmp2_ = data;
	_tmp3_ = delimiter;
	_tmp4_ = max_tokens;
	_tmp6_ = _tmp5_ = g_strsplit (_tmp2_, _tmp3_, _tmp4_);
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _vala_array_length (_tmp5_);
	_tmp8_ = drt_string_array_to_slist (_tmp7_, _vala_array_length (_tmp5_), TRUE);
	_tmp9_ = _tmp8_;
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
	result = _tmp9_;
	return result;
}


/**
 * Creates list from array of strings
 * 
 * @param array    string array
 * @param strip    strip array elements and ignore empty elements
 * @return resulting list of strings
 */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static inline void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}


GSList* drt_string_array_to_slist (gchar** array, int array_length1, gboolean strip) {
	GSList* result = NULL;
	GSList* _result_ = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GSList* _tmp11_;
	_result_ = NULL;
	_tmp0_ = array;
	_tmp0__length1 = array_length1;
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
		item_collection = _tmp0_;
		item_collection_length1 = _tmp0__length1;
		for (item_it = 0; item_it < _tmp0__length1; item_it = item_it + 1) {
			const gchar* item = NULL;
			item = item_collection[item_it];
			{
				gboolean _tmp1_;
				_tmp1_ = strip;
				if (!_tmp1_) {
					const gchar* _tmp2_;
					gchar* _tmp3_;
					_tmp2_ = item;
					_tmp3_ = g_strdup (_tmp2_);
					_result_ = g_slist_prepend (_result_, _tmp3_);
				} else {
					const gchar* _tmp4_;
					gboolean _tmp5_;
					_tmp4_ = item;
					_tmp5_ = drt_string_is_empty (_tmp4_);
					if (!_tmp5_) {
						gchar* stripped_item = NULL;
						const gchar* _tmp6_;
						gchar* _tmp7_;
						const gchar* _tmp8_;
						gboolean _tmp9_;
						_tmp6_ = item;
						_tmp7_ = string_strip (_tmp6_);
						stripped_item = _tmp7_;
						_tmp8_ = stripped_item;
						_tmp9_ = drt_string_is_empty (_tmp8_);
						if (!_tmp9_) {
							gchar* _tmp10_;
							_tmp10_ = stripped_item;
							stripped_item = NULL;
							_result_ = g_slist_prepend (_result_, _tmp10_);
						}
						_g_free0 (stripped_item);
					}
				}
			}
		}
	}
	_result_ = g_slist_reverse (_result_);
	_tmp11_ = _result_;
	_result_ = NULL;
	result = _tmp11_;
	__g_slist_free__g_free0_0 (_result_);
	return result;
}


/**
 * Parse a string containing semicolon-separated set of items
 * 
 * @param dataset    semicolon-separated set of items
 * @return a set data structurecontaining all unique items from data set
 */
GHashTable* drt_string_semicolon_separated_set (const gchar* dataset, gboolean lowercase) {
	GHashTable* result = NULL;
	GHashTable* _result_ = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
	_result_ = _tmp2_;
	_tmp3_ = dataset;
	_tmp4_ = drt_string_is_empty (_tmp3_);
	if (!_tmp4_) {
		gchar** items = NULL;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint items_length1;
		gint _items_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp5_ = dataset;
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ";", 0);
		items = _tmp7_;
		items_length1 = _vala_array_length (_tmp6_);
		_items_size_ = items_length1;
		_tmp8_ = items;
		_tmp8__length1 = items_length1;
		{
			gchar** item_collection = NULL;
			gint item_collection_length1 = 0;
			gint _item_collection_size_ = 0;
			gint item_it = 0;
			item_collection = _tmp8_;
			item_collection_length1 = _tmp8__length1;
			for (item_it = 0; item_it < _tmp8__length1; item_it = item_it + 1) {
				gchar* _tmp9_;
				gchar* item = NULL;
				_tmp9_ = g_strdup (item_collection[item_it]);
				item = _tmp9_;
				{
					const gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar _tmp13_;
					_tmp10_ = item;
					_tmp11_ = string_strip (_tmp10_);
					_g_free0 (item);
					item = _tmp11_;
					_tmp12_ = item;
					_tmp13_ = string_get (_tmp12_, (glong) 0);
					if (((gint) _tmp13_) != 0) {
						gchar* _tmp14_ = NULL;
						gboolean _tmp15_;
						GHashTable* _tmp20_;
						gchar* _tmp21_;
						_tmp15_ = lowercase;
						if (_tmp15_) {
							const gchar* _tmp16_;
							gchar* _tmp17_;
							_tmp16_ = item;
							_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
							_g_free0 (_tmp14_);
							_tmp14_ = _tmp17_;
						} else {
							const gchar* _tmp18_;
							gchar* _tmp19_;
							_tmp18_ = item;
							_tmp19_ = g_strdup (_tmp18_);
							_g_free0 (_tmp14_);
							_tmp14_ = _tmp19_;
						}
						_tmp20_ = _result_;
						_tmp21_ = g_strdup (_tmp14_);
						g_hash_table_add (_tmp20_, _tmp21_);
						_g_free0 (_tmp14_);
					}
					_g_free0 (item);
				}
			}
		}
		items = (_vala_array_free (items, items_length1, (GDestroyNotify) g_free), NULL);
	}
	result = _result_;
	return result;
}


gint drt_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
	g_return_val_if_fail (str != NULL, 0);
	_tmp0_ = str;
	_tmp1_ = start_index;
	_tmp2_ = len;
	_tmp3_ = c;
	_tmp4_ = g_utf8_strchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
	_result_ = _tmp4_;
	_tmp6_ = _result_;
	if (_tmp6_ != NULL) {
		gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = _result_;
		_tmp8_ = str;
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
	} else {
		_tmp5_ = -1;
	}
	result = _tmp5_;
	return result;
}


gint drt_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_ = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
	g_return_val_if_fail (str != NULL, 0);
	_tmp0_ = str;
	_tmp1_ = start_index;
	_tmp2_ = len;
	_tmp3_ = c;
	_tmp4_ = g_utf8_strrchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
	_result_ = _tmp4_;
	_tmp6_ = _result_;
	if (_tmp6_ != NULL) {
		gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = _result_;
		_tmp8_ = str;
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
	} else {
		_tmp5_ = -1;
	}
	result = _tmp5_;
	return result;
}


gchar* drt_string_unmask (guint8* data, int data_length1) {
	gchar* result = NULL;
	gint length = 0;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	guint8 shift = 0U;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8 _tmp3_;
	guint8* _result_ = NULL;
	gint _tmp4_;
	guint8* _tmp5_;
	gint _result__length1;
	gint __result__size_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8 _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	_tmp0_ = data;
	_tmp0__length1 = data_length1;
	length = _tmp0__length1;
	_tmp1_ = length;
	if (_tmp1_ < 2) {
		result = NULL;
		return result;
	}
	_tmp2_ = data;
	_tmp2__length1 = data_length1;
	_tmp3_ = _tmp2_[0];
	shift = _tmp3_;
	_tmp4_ = length;
	_tmp5_ = g_new0 (guint8, _tmp4_);
	_result_ = _tmp5_;
	_result__length1 = _tmp4_;
	__result__size_ = _result__length1;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				guint8 _tmp10_;
				guint8* _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				guint8 _tmp13_;
				guint8* _tmp14_;
				gint _tmp14__length1;
				gint _tmp15_;
				guint8* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				guint8 _tmp20_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = length;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = shift;
				_tmp11_ = data;
				_tmp11__length1 = data_length1;
				_tmp12_ = i;
				_tmp13_ = _tmp11_[_tmp12_];
				if (_tmp10_ > _tmp13_) {
					result = NULL;
					_result_ = (g_free (_result_), NULL);
					return result;
				}
				_tmp14_ = _result_;
				_tmp14__length1 = _result__length1;
				_tmp15_ = i;
				_tmp16_ = data;
				_tmp16__length1 = data_length1;
				_tmp17_ = i;
				_tmp18_ = _tmp16_[_tmp17_];
				_tmp19_ = shift;
				_tmp14_[_tmp15_ - 1] = _tmp18_ - _tmp19_;
				_tmp20_ = _tmp14_[_tmp15_ - 1];
			}
		}
	}
	_tmp21_ = _result_;
	_tmp21__length1 = _result__length1;
	_tmp22_ = length;
	_tmp21_[_tmp22_] = (guint8) 0;
	_tmp23_ = _tmp21_[_tmp22_];
	_tmp24_ = _result_;
	_tmp24__length1 = _result__length1;
	_tmp25_ = g_strdup ((const gchar*) _tmp24_);
	result = _tmp25_;
	_result_ = (g_free (_result_), NULL);
	return result;
}


/**
 * Return the number of UTF-16 code points to store given string.
 * 
 * It corresponds to JavaScript's String.length.
 * 
 * @param str    a string
 * @return a number of UTF-16 code points
 */
static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_;
	gunichar _tmp1_;
	gunichar _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = *index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	_vala_c = _tmp1_;
	_tmp2_ = _vala_c;
	if (_tmp2_ != ((gunichar) 0)) {
		gint _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = *index;
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
		*index = (gint) (_tmp4_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


gint drt_string_utf16_strlen (const gchar* str) {
	gint result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gint len = 0;
	gunichar c = 0U;
	gint i = 0;
	_tmp0_ = str;
	_tmp1_ = drt_string_is_empty (_tmp0_);
	if (_tmp1_) {
		result = 0;
		return result;
	}
	len = 0;
	c = (gunichar) 0;
	i = 0;
	while (TRUE) {
		const gchar* _tmp2_;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint _tmp5_ = 0;
		gunichar _tmp6_;
		gint _tmp7_;
		_tmp2_ = str;
		_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
		c = _tmp3_;
		if (!_tmp4_) {
			break;
		}
		_tmp6_ = c;
		if (((guint) _tmp6_) <= ((guint) 0xFFFF)) {
			_tmp5_ = 1;
		} else {
			_tmp5_ = 2;
		}
		_tmp7_ = len;
		len = _tmp7_ + _tmp5_;
	}
	result = len;
	return result;
}


/**
 * Create unowned string at the given offset
 * 
 * @param str       the parent string
 * @param offset    starting offset
 * @return unowned substring starting at given offset
 */
const gchar* drt_string_offset (const gchar* str, gint offset) {
	const gchar* result = NULL;
	gint _tmp0_;
	guint8* pointer = NULL;
	const gchar* _tmp1_;
	gint _tmp2_;
	const gchar* _result_ = NULL;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = offset;
	_vala_assert (_tmp0_ >= 0, "offset >= 0");
	_tmp1_ = str;
	_tmp2_ = offset;
	pointer = ((guint8*) _tmp1_) + _tmp2_;
	_result_ = (const gchar*) pointer;
	result = _result_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



